@REM Run from CMD.exe in the directory of the script.
@echo off
call Make-Settings.bat
IF ERRORLEVEL 1 goto :dir_error

REM Target directory
set TARGET_DIR=%SITE_DIR%\productions\atari800\%RELEASE_LOWERCASE%
if not exist %TARGET_DIR% mkdir %TARGET_DIR%

REM Target file name prefix
set TARGET_NAME=%TARGET_DIR%\%RELEASE_LOWERCASE%
if exist %WINRAR% call :create_src_zip

set MADS_DEFINES=-d:standalone=1
call :mads %RELEASE%-Blitter-$d600 xex
call :mads %RELEASE%-Blitter-$d700 xex
call :mads %RELEASE%-Blitter-DOS xex

del /Q *.atdbg
del /Q *.lab
del /Q *.lst

call :convert_xex_to_atr

rem start %FILE%.xex

set MADS_DEFINES=-d:standalone=0
call :mads %RELEASE%-Blitter-$d600 xex
call :mads %RELEASE%-Blitter-$d700 xex
call :mads EmptyCart rom
call :mads %RELEASE%-Blitter-Atarimax rom

del /Q *.atdbg
del /Q *.lab
del /Q *.lst

call :convert_rom_to_car

rem start %FILE%.car

if exist %WINRAR% call :convert_to_zip
copy  %RELEASE%.gif %TARGET_NAME%.gif
 
start %TARGET_DIR%
goto :eof


:mads
set FILE=%1
%MADS% %FILE%.asm %MADS_DEFINES% -t:%FILE%.lab -l:%FILE%.lst -o:%FILE%.%2
if ERRORLEVEL 1 goto :mads_error
goto :eof

:mads_error
echo ERROR: MADS compilation errors occurred. Check error messages above.
pause
exit

:error
echo ERROR: Check error message above.
pause
exit

:convert_xex_to_atr
echo Converting %FILE% to %FILE%.atr
copy  %FILE%.xex atr\AUTORUN.AR0
if ERRORLEVEL 1 goto :error
%DIR2ATR% -d -m -b MyDos4534 %FILE%.atr atr
if ERRORLEVEL 1 goto :error
del atr\AUTORUN.AR0
if ERRORLEVEL 1 goto :error
goto :eof

:convert_rom_to_car
echo Converting %FILE% to %FILE%.car
java -jar bin\AtariRomMaker.jar -load:"%FILE%.rom" -convertToCAR:42 -save:"%FILE%.car"
goto :eof

:convert_to_zip
set TARGET_FILE=%TARGET_NAME%.zip
echo Creating %TARGET_FILE%
if exist %TARGET_FILE% del %TARGET_FILE%
%WINRAR% a -afzip %TARGET_FILE% %RELEASE%.txt %RELEASE%-Blitter-DOS.xex %RELEASE%-Blitter-DOS.atr %RELEASE%-Blitter-Atarimax.rom %RELEASE%-Blitter-Atarimax.car
goto :eof

:create_src_zip
del /Q *.lst *.lab *.atdbg
del /Q *.xex *.rom *.car
set TARGET_FILE=%TARGET_NAME%-source.zip
echo Creating %TARGET_FILE%
if exist %TARGET_FILE% del %TARGET_FILE%
%WINRAR% a -afzip %TARGET_FILE% ..\..\%RELEASE%
goto :eof

:dir_error
echo ERROR: Invalid working directory.
pause
exit
