;	@com.wudsn.ide.asm.mainsourcefile=ST-ONT-Blitter.asm

; LZSS Compressed SAP player for 16 match bits
; --------------------------------------------
;
; (c) 2020 DMSC
; Code under MIT license, see LICENSE file.
;
; This player uses:
;  Match length: 8 bits  (1 to 256)
;  Match offset: 8 bits  (1 to 256)
;  Min length: 2
;  Total match bits: 16 bits
;
; Compress using:
;  lzss -b 16 -o 8 -m 1 input.rsap test.lz12
;
; Assemble this file with MADS assembler, the compressed song is expected in
; the `test.lz16` file at assembly time.
;
; The plater needs 256 bytes of buffer for each pokey register stored, for a
; full SAP file this is 2304 bytes.
;
;    org $80

;chn_copy    .ds     9
;chn_pos     .ds     9
;bbptr        .ds     2
;cur_pos     .ds     1
;chn_bits    .ds     1

;bit_data    .byte   1

music	= $2000
rmt_player.init = $3400
rmt_player.play = $3403	;Uses zero page $c3-$ff

	.macro m_init_2nd_pokey
	mva #$03 SKCTL+$10
	.endm

	.macro m_update_2nd_pokey
	ldy #$00
	lda $3154
	ldx $3158
	sta AUDF1+$10
	stx AUDC1+$10
	lda $3155
	ldx $3159
	sta AUDF2+$10
	stx AUDC2+$10
	lda $3156
	ldx $315A
	sta AUDF3+$10
	stx AUDC3+$10
	lda $3157
	ldx $315B
	sta AUDF4+$10
	stx AUDC4+$10
	sty AUDCTL+$10
	.endm
